~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/extract-ikconfig

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/extract-ikconfig (Version linux-6.11.5) and /scripts/extract-ikconfig (Version linux-4.11.12)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # --------------------------------------------      2 # ----------------------------------------------------------------------
  3 # extract-ikconfig - Extract the .config file       3 # extract-ikconfig - Extract the .config file from a kernel image
  4 #                                                   4 #
  5 # This will only work when the kernel was comp      5 # This will only work when the kernel was compiled with CONFIG_IKCONFIG.
  6 #                                                   6 #
  7 # The obscure use of the "tr" filter is to wor      7 # The obscure use of the "tr" filter is to work around older versions of
  8 # "grep" that report the byte offset of the li      8 # "grep" that report the byte offset of the line instead of the pattern.
  9 #                                                   9 #
 10 # (c) 2009,2010 Dick Streefland <dick@streeflan     10 # (c) 2009,2010 Dick Streefland <dick@streefland.net>
 11 # Licensed under the terms of the GNU General      11 # Licensed under the terms of the GNU General Public License.
 12 # --------------------------------------------     12 # ----------------------------------------------------------------------
 13                                                    13 
 14 cf1='IKCFG_ST\037\213\010'                         14 cf1='IKCFG_ST\037\213\010'
 15 cf2='0123456789'                                   15 cf2='0123456789'
 16                                                    16 
 17 dump_config()                                      17 dump_config()
 18 {                                                  18 {
 19         if      pos=`tr "$cf1\n$cf2" "\n$cf2="     19         if      pos=`tr "$cf1\n$cf2" "\n$cf2=" < "$1" | grep -abo "^$cf2"`
 20         then                                       20         then
 21                 pos=${pos%%:*}                     21                 pos=${pos%%:*}
 22                 tail -c+$(($pos+8)) "$1" | zca     22                 tail -c+$(($pos+8)) "$1" | zcat > $tmp1 2> /dev/null
 23                 if      [ $? != 1 ]                23                 if      [ $? != 1 ]
 24                 then    # exit status must be      24                 then    # exit status must be 0 or 2 (trailing garbage warning)
 25                         cat $tmp1                  25                         cat $tmp1
 26                         exit 0                     26                         exit 0
 27                 fi                                 27                 fi
 28         fi                                         28         fi
 29 }                                                  29 }
 30                                                    30 
 31 try_decompress()                                   31 try_decompress()
 32 {                                                  32 {
 33         for     pos in `tr "$1\n$2" "\n$2=" <      33         for     pos in `tr "$1\n$2" "\n$2=" < "$img" | grep -abo "^$2"`
 34         do                                         34         do
 35                 pos=${pos%%:*}                     35                 pos=${pos%%:*}
 36                 tail -c+$pos "$img" | $3 > $tm     36                 tail -c+$pos "$img" | $3 > $tmp2 2> /dev/null
 37                 dump_config $tmp2                  37                 dump_config $tmp2
 38         done                                       38         done
 39 }                                                  39 }
 40                                                    40 
 41 # Check invocation:                                41 # Check invocation:
 42 me=${0##*/}                                        42 me=${0##*/}
 43 img=$1                                             43 img=$1
 44 if      [ $# -ne 1 -o ! -s "$img" ]                44 if      [ $# -ne 1 -o ! -s "$img" ]
 45 then                                               45 then
 46         echo "Usage: $me <kernel-image>" >&2       46         echo "Usage: $me <kernel-image>" >&2
 47         exit 2                                     47         exit 2
 48 fi                                                 48 fi
 49                                                    49 
 50 # Prepare temp files:                              50 # Prepare temp files:
 51 tmp1=/tmp/ikconfig$$.1                             51 tmp1=/tmp/ikconfig$$.1
 52 tmp2=/tmp/ikconfig$$.2                             52 tmp2=/tmp/ikconfig$$.2
 53 trap "rm -f $tmp1 $tmp2" 0                         53 trap "rm -f $tmp1 $tmp2" 0
 54                                                    54 
 55 # Initial attempt for uncompressed images or o     55 # Initial attempt for uncompressed images or objects:
 56 dump_config "$img"                                 56 dump_config "$img"
 57                                                    57 
 58 # That didn't work, so retry after decompressi     58 # That didn't work, so retry after decompression.
 59 try_decompress '\037\213\010' xy    gunzip         59 try_decompress '\037\213\010' xy    gunzip
 60 try_decompress '\3757zXZ\000' abcde unxz           60 try_decompress '\3757zXZ\000' abcde unxz
 61 try_decompress 'BZh'          xy    bunzip2        61 try_decompress 'BZh'          xy    bunzip2
 62 try_decompress '\135\0\0\0'   xxx   unlzma         62 try_decompress '\135\0\0\0'   xxx   unlzma
 63 try_decompress '\211\114\132' xy    'lzop -d'      63 try_decompress '\211\114\132' xy    'lzop -d'
 64 try_decompress '\002\041\114\030' xyy 'lz4 -d      64 try_decompress '\002\041\114\030' xyy 'lz4 -d -l'
 65 try_decompress '\050\265\057\375' xxx unzstd   << 
 66                                                    65 
 67 # Bail out:                                        66 # Bail out:
 68 echo "$me: Cannot find kernel config." >&2         67 echo "$me: Cannot find kernel config." >&2
 69 exit 1                                             68 exit 1
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php